/* Program skeleton for Problem B (File Browser) */

#include <stdio.h>
#include <stdlib.h>
#include "stdmotif.h"

#ifdef __STDC__     /* diese Funktionsdeklaration gilt in ANSI-C: */
void handle_menu (Widget widget, XtPointer client_data, XtPointer call_data);
#else               /* und diese in Kernighan/Ritchie-C: */
void handle_menu ();
#endif

Widget toplevel;

/************************* MAIN PROGRAM **************************/

#ifdef __STDC__     /* dieser Funktionskopf gilt in ANSI-C: */
int main (int argc, char *argv[])
#else               /* und dieser in Kernighan/Ritchie-C: */
int main (argc, argv)
  int argc;
  char *argv[];
#endif
{
  Widget        main_w,  /* main window */
                menubar, /* the one-entry menu bar */
                menu,    /* the pulldown menu */
                label;   /* The label displayed in the work window */
  XtAppContext  app;

  /*---------- 1. initialize X and Motif ------------------------------*/
  /* (already complete, should not be changed) */
  globalInitialize ("B");
  toplevel = XtVaAppInitialize (&app, "Hello", NULL, 0,
        &argc, argv, fallbacks, NULL);

  /*---------- 2. create and configure widgets -------------------------*/
  
  /* Erzeuge MainWindow widget 'main_w' mit parent 'toplevel'; */
  /* Erzeuge MenuBar 'menubar' mit Eintrag 'File Browser' in 'LARGE' Font */
  /*   und mit parent 'main_w'; */
  /* Erzeuge Label widget 'label' mit Eintrag 'by <Name>' in 'SMALL' Font; */
  /* Trage 'label' als 'workWindow' von 'main_w' ein; */
  /* Erzeuge PulldownMenu 'menu' mit Eintraegen 'Select file', */
  /*   'Open selected file' und 'Quit' (callback-Funktion 'handle_menu'); */

  /*---------- 3. register callback functions -------------------------*/
  /* (handle_menu was already registered above, nothing needs to be done) */
  
  /*---------- 4. realize widgets and turn control to X event loop -----*/
  /* (already complete, should not be changed) */
  XtRealizeWidget (toplevel);
  XtAppMainLoop (app);
  return (0);
}


/************************* Functions *************************/

#ifdef __STDC__     /* dieser Funktionskopf gilt in ANSI-C: */
void handle_menu (Widget widget, XtPointer client_data, XtPointer call_data)
#else               /* und dieser in Kernighan/Ritchie-C: */
void handle_menu (widget, client_data, call_data)
  Widget widget;
  XtPointer client_data;
  XtPointer call_data;
#endif
{
  Widget fs;
  if ((int)client_data == 0) {  /**** first menu entry selected ****/
    Widget fs;
    /* Erzeuge und manage FileSelectorDialog 'fs'; */
    /* Trage 'keepSelectedFile' als callback Funktion des 'OK' buttons ein; */
  }
  else if ((int)client_data == 1) {  /**** second menu entry selected ****/
    Widget scrolltext;
    /* Erzeuge 25 x 80 Zeichen grosses ScrolledTextWindow 'scrolltext' mit */
    /*   parent 'toplevel' und dem gewaehlten Dateinamen als Titel */
    /* Lese die gewaehlte Datei ein und trage den Inhalt in die 'value' */
    /*   resource von 'scrolltext' ein; */
  }
  else if ((int)client_data == 2) {  /**** third menu entry selected ****/
    /* rufe 'exit' auf */
  }
}
